Loading...
Searching...
No Matches
pcl::DecisionForestTrainer< FeatureType, DataSet, LabelType, ExampleIndex, NodeType > Class Template Reference

Trainer for decision trees. More...

`#include <pcl/ml/dt/decision_forest_trainer.h>`

## Public Member Functions

| DecisionForestTrainer ()
| Constructor.
virtual | ~DecisionForestTrainer ()
| Destructor.
void | setNumberOfTreesToTrain (const std::size_t num_of_trees)
| Sets the number of trees to train.
void | setFeatureHandler (pcl::FeatureHandler< FeatureType, DataSet, ExampleIndex > &feature_handler)
| Sets the feature handler used to create and evaluate features.
void | setStatsEstimator (pcl::StatsEstimator< LabelType, NodeType, DataSet, ExampleIndex > &stats_estimator)
| Sets the object for estimating the statistics for tree nodes.
void | setMaxTreeDepth (const std::size_t max_tree_depth)
| Sets the maximum depth of the learned tree.
void | setNumOfFeatures (const std::size_t num_of_features)
| Sets the number of features used to find optimal decision features.
void | setNumOfThresholds (const std::size_t num_of_threshold)
| Sets the number of thresholds tested for finding the optimal decision threshold on the feature responses.
void | setTrainingDataSet (DataSet &data_set)
| Sets the input data set used for training.
void | setExamples (std::vector< ExampleIndex > &examples)
| Example indices that specify the data used for training.
void | setLabelData (std::vector< LabelType > &label_data)
| Sets the label data corresponding to the example data.
void | setMinExamplesForSplit (std::size_t n)
| Sets the minimum number of examples to continue growing a tree.
void | setThresholds (std::vector< float > &thres)
| Specify the thresholds to be used when evaluating features.
void | setDecisionTreeDataProvider (typename pcl::DecisionTreeTrainerDataProvider< FeatureType, DataSet, LabelType, ExampleIndex, NodeType >::Ptr &dtdp)
| Specify the data provider.
void | setRandomFeaturesAtSplitNode (bool b)
| Specify if the features are randomly generated at each split node.
void | train (DecisionForest< NodeType > &forest)
| Trains a decision forest using the set training data and settings.

## Detailed Description

template<class FeatureType, class DataSet, class LabelType, class ExampleIndex, class NodeType>
class pcl::DecisionForestTrainer< FeatureType, DataSet, LabelType, ExampleIndex, NodeType >

Trainer for decision trees.

Definition at line 57 of file decision_forest_trainer.h.

## Constructor & Destructor Documentation

## DecisionForestTrainer()

template<class FeatureType , class DataSet , class LabelType , class ExampleIndex , class NodeType >

pcl::DecisionForestTrainer< FeatureType, DataSet, LabelType, ExampleIndex, NodeType >::DecisionForestTrainer | ( |  | ) |

Constructor.

Definition at line 47 of file decision_forest_trainer.hpp.

## ~DecisionForestTrainer()

template<class FeatureType , class DataSet , class LabelType , class ExampleIndex , class NodeType >

pcl::DecisionForestTrainer< FeatureType, DataSet, LabelType, ExampleIndex, NodeType >::~DecisionForestTrainer | ( |  | ) |

virtual default

Destructor.

## Member Function Documentation

## setDecisionTreeDataProvider()

template<class FeatureType , class DataSet , class LabelType , class ExampleIndex , class NodeType >

void pcl::DecisionForestTrainer< FeatureType, DataSet, LabelType, ExampleIndex, NodeType >::setDecisionTreeDataProvider | ( | typename pcl::DecisionTreeTrainerDataProvider< FeatureType, DataSet, LabelType, ExampleIndex, NodeType >::Ptr & | dtdp | ) |

inline

Specify the data provider.

Parameters

  [in] | dtdp | the data provider that should implement getDatasetAndLabels() function

Definition at line 185 of file decision_forest_trainer.h.

## setExamples()

template<class FeatureType , class DataSet , class LabelType , class ExampleIndex , class NodeType >

void pcl::DecisionForestTrainer< FeatureType, DataSet, LabelType, ExampleIndex, NodeType >::setExamples | ( | std::vector< ExampleIndex > & | examples | ) |

inline

Example indices that specify the data used for training.

Parameters

  [in] | examples | the examples

Definition at line 144 of file decision_forest_trainer.h.

## setFeatureHandler()

template<class FeatureType , class DataSet , class LabelType , class ExampleIndex , class NodeType >

void pcl::DecisionForestTrainer< FeatureType, DataSet, LabelType, ExampleIndex, NodeType >::setFeatureHandler | ( | pcl::FeatureHandler< FeatureType, DataSet, ExampleIndex > & | feature_handler | ) |

inline

Sets the feature handler used to create and evaluate features.

Parameters

  [in] | feature_handler | the feature handler

Definition at line 81 of file decision_forest_trainer.h.

## setLabelData()

template<class FeatureType , class DataSet , class LabelType , class ExampleIndex , class NodeType >

void pcl::DecisionForestTrainer< FeatureType, DataSet, LabelType, ExampleIndex, NodeType >::setLabelData | ( | std::vector< LabelType > & | label_data | ) |

inline

Sets the label data corresponding to the example data.

Parameters

  [in] | label_data | the label data

Definition at line 154 of file decision_forest_trainer.h.

## setMaxTreeDepth()

template<class FeatureType , class DataSet , class LabelType , class ExampleIndex , class NodeType >

void pcl::DecisionForestTrainer< FeatureType, DataSet, LabelType, ExampleIndex, NodeType >::setMaxTreeDepth | ( | const std::size_t | max_tree_depth | ) |

inline

Sets the maximum depth of the learned tree.

Parameters

  [in] | max_tree_depth | maximum depth of the learned tree

Definition at line 103 of file decision_forest_trainer.h.

## setMinExamplesForSplit()

template<class FeatureType , class DataSet , class LabelType , class ExampleIndex , class NodeType >

void pcl::DecisionForestTrainer< FeatureType, DataSet, LabelType, ExampleIndex, NodeType >::setMinExamplesForSplit | ( | std::size_t | n | ) |

inline

Sets the minimum number of examples to continue growing a tree.

Parameters

  [in] | n | number of examples

Definition at line 164 of file decision_forest_trainer.h.

## setNumberOfTreesToTrain()

template<class FeatureType , class DataSet , class LabelType , class ExampleIndex , class NodeType >

void pcl::DecisionForestTrainer< FeatureType, DataSet, LabelType, ExampleIndex, NodeType >::setNumberOfTreesToTrain | ( | const std::size_t | num_of_trees | ) |

inline

Sets the number of trees to train.

Parameters

  [in] | num_of_trees | the number of trees

Definition at line 71 of file decision_forest_trainer.h.

## setNumOfFeatures()

template<class FeatureType , class DataSet , class LabelType , class ExampleIndex , class NodeType >

void pcl::DecisionForestTrainer< FeatureType, DataSet, LabelType, ExampleIndex, NodeType >::setNumOfFeatures | ( | const std::size_t | num_of_features | ) |

inline

Sets the number of features used to find optimal decision features.

Parameters

  [in] | num_of_features | the number of features

Definition at line 113 of file decision_forest_trainer.h.

## setNumOfThresholds()

template<class FeatureType , class DataSet , class LabelType , class ExampleIndex , class NodeType >

void pcl::DecisionForestTrainer< FeatureType, DataSet, LabelType, ExampleIndex, NodeType >::setNumOfThresholds | ( | const std::size_t | num_of_threshold | ) |

inline

Sets the number of thresholds tested for finding the optimal decision threshold on the feature responses.

Parameters

  [in] | num_of_threshold | the number of thresholds

Definition at line 124 of file decision_forest_trainer.h.

## setRandomFeaturesAtSplitNode()

template<class FeatureType , class DataSet , class LabelType , class ExampleIndex , class NodeType >

void pcl::DecisionForestTrainer< FeatureType, DataSet, LabelType, ExampleIndex, NodeType >::setRandomFeaturesAtSplitNode | ( | bool | b | ) |

inline

Specify if the features are randomly generated at each split node.

Parameters

  [in] | b | do it or not

Definition at line 200 of file decision_forest_trainer.h.

## setStatsEstimator()

template<class FeatureType , class DataSet , class LabelType , class ExampleIndex , class NodeType >

void pcl::DecisionForestTrainer< FeatureType, DataSet, LabelType, ExampleIndex, NodeType >::setStatsEstimator | ( | pcl::StatsEstimator< LabelType, NodeType, DataSet, ExampleIndex > & | stats_estimator | ) |

inline

Sets the object for estimating the statistics for tree nodes.

Parameters

  [in] | stats_estimator | the statistics estimator

Definition at line 92 of file decision_forest_trainer.h.

## setThresholds()

template<class FeatureType , class DataSet , class LabelType , class ExampleIndex , class NodeType >

void pcl::DecisionForestTrainer< FeatureType, DataSet, LabelType, ExampleIndex, NodeType >::setThresholds | ( | std::vector< float > & | thres | ) |

inline

Specify the thresholds to be used when evaluating features.

Parameters

  [in] | thres | the threshold values

Definition at line 174 of file decision_forest_trainer.h.

## setTrainingDataSet()

template<class FeatureType , class DataSet , class LabelType , class ExampleIndex , class NodeType >

void pcl::DecisionForestTrainer< FeatureType, DataSet, LabelType, ExampleIndex, NodeType >::setTrainingDataSet | ( | DataSet & | data_set | ) |

inline

Sets the input data set used for training.

Parameters

  [in] | data_set | the data set used for training

Definition at line 134 of file decision_forest_trainer.h.

## train()

template<class FeatureType , class DataSet , class LabelType , class ExampleIndex , class NodeType >

void pcl::DecisionForestTrainer< FeatureType, DataSet, LabelType, ExampleIndex, NodeType >::train | ( | pcl::DecisionForest< NodeType > & | forest | ) |

Trains a decision forest using the set training data and settings.

Parameters

  [out] | forest | destination for the trained forest

Definition at line 66 of file decision_forest_trainer.hpp.

The documentation for this class was generated from the following files:

- pcl/ml/dt/decision_forest_trainer.h
- pcl/ml/impl/dt/decision_forest_trainer.hpp